
var app = {
    
    loaded: false,
    webApp: null,
    lang: null,
    langVars: null,
	services: Array(),
	currIds: {
		phrases: 9999,
		answers: 9999
	},
	showCircular: false,
	dialogAction: "",
    
    load: function() {
        this.loaded = true;
    },
    
    start: function() {
        mwe.resize();
        if ( !this.loaded ) this.load();
        
        try {
            this.setParams();
            this.getSkills();
        }
        catch(e){}

                $(window).resize(function(){mwe.resize();});
    },
    
    setParams: function() {
        this.setLang();
    },
    
    setLang: function() {
        this.lang = Switty.get("help.lang").toLowerCase();
        mwe.includeScript("lang/" + this.lang + ".js", function() {
            app.langVars = lang;
        }, document.getElementsByName("body")[0]);
    },
	/*
	 *
	 */
	getSkills: function() {
		var apiSkillTable 		= JSON.parse( Switty.get("help.apiSkillTable") );
		var serviceSkillTable 	= JSON.parse( Switty.get("help.serviceSkillTable") );
		var helpVariable		= Switty.get("help.helpVariable");
		var lang 				= Switty.get("help.lang");
		
		/* fill the services pool from apiSkillsTable */
		for ( var key in apiSkillTable ) {
			var skillId      = apiSkillTable[key]["id"];
			var skillDialog  = Switty.getDefiningDialog(skillId+"."+helpVariable);
			
			if ( skillDialog != "NO_VAR" && skillDialog != "NO_DEFINING_DIALOG" ) {
			    this["services"].push({
					id:          skillId,
					dialog:      skillDialog,
			        helpText:    Switty.get(skillId+"."+helpVariable),
			        icon:        apiSkillTable[key]["icon"],
			        weight:      apiSkillTable[key]["weight"]*100
			    });
			}
		}
		
		/* complete the services pool from serviceSkillTable */
		for ( var key in serviceSkillTable ) {
		    this["services"].push({
				id:       serviceSkillTable[key]["id"],
				dialog:   serviceSkillTable[key]["dialog"],
		        helpText: serviceSkillTable[key]["helpText"],
		        icon:     serviceSkillTable[key]["icon"],
		        weight:   serviceSkillTable[key]["weight"]*100
		    });
		}
		
		this.sortSkills();
	},
	sortSkills: function() {
	    this["services"].sort(function(a, b) { return b.weight - a.weight; });
	    
		this.draw();
	},
    /*
     * 
     */
    draw: function() {
		this.showList();
        this.showPhrase();
		
		if (this.showCircular) mwe.timer = setInterval("app.showPhrase()", 20000);
		
		$("#hlist li").bind("click", function() { 
			var attrId 		= $(this).attr("id");
			var itemId 		= attrId.replace("item-", "");
			var itemState 	= app.services[itemId]["dialog"];
			
			switty.hideAllDialogs();
			switty.setVariable("help.transition", itemState);
			app.dialogAction = "Transition";
			answer();
		});
    },
    bind: function() {
		$(".b-hlist__item").each(function() {
			mwe.bindTouchState($(this), "touchactive");
		});
    },
	showList: function() {
	    var listHtml = "";
		
	    for ( var key in this.services ) {
	        var itemIcon  	= this.services[key]["icon"];
	        var itemDescr 	= this.services[key]["helpText"];
	        
	        listHtml += "<li class='b-hlist__item' id='item-"+key+"'>\n\
	           <img src='"+itemIcon+"' class='b-icon' width='60' />\n\
	           <div class='b-hlist__item_descr'>"+itemDescr+"</div>\n\
			   </li>";
	    }
	    
		$("#hlist").empty();
	    $("#hlist").append(listHtml);
		var myScroll = new iScroll("content", { vScrollbar:true });
		this.bind();
		setTimeout(function() {
			myScroll.refresh();
		}, 200);
	},
	showPhrase: function() {
		var phraseId = mwe.genRandom(app.langVars["phrases"].length);
		var answerId = mwe.genRandom(app.langVars["answers"].length);
		
		while ( phraseId == this.currIds["phrases"] ) {
			phraseId = mwe.genRandom(app.langVars["phrases"].length);
		}
		while ( answerId == this.currIds["answers"] ) {
			answerId = mwe.genRandom(app.langVars["answers"].length);
		}
		this.currIds["phrases"] = phraseId;
		this.currIds["answers"] = answerId;
		
		var phrase = this.langVars["phrases"][phraseId];
		var answer = this.langVars["answers"][answerId];
		
		this.dialogAction = this.langVars["answers"][answerId]["action"];
		
		try {
                    console.log(answer.text, app.langVars["about"]);
                    switty.playAnimation(["34", "12"]);
                    switty.sayWithVoice( phrase, phrase, [ answer.text,  app.langVars["about"] ] );
                }
		catch(e) {}
	}
};

function webAppReady() {
	app.webApp = true;
	app.setLang();
	app.start();
	Switty.playAnimation(["11", "12"]);
}

jQuery(function( $ ) {
	if ( !app.loaded ) {
		app.setLang();
	}
});

function answer(id) {
	if (app.showCircular) clearInterval(mwe.timer);
	
    switch(app.dialogAction) {
        case "return":
            if(id==0) switty.closeWebApp("Exit");
            if(id==1) app.showList();
            break;
	case "Suggestion":
            if(id==0) switty.closeWebApp("Suggestion");
            if(id==1) switty.closeWebApp("About");
            break;
        case "HowTo":
            if(id==0) switty.closeWebApp("HowTo");
            if(id==1) switty.closeWebApp("About");
            break;
        case "ThatsAll":
            if(id==0) switty.closeWebApp("ThatsAll");
            if(id==1) switty.closeWebApp("About");
            break;
        case "Transition":
            if(id==0) switty.closeWebApp("Transition");
            if(id==1) switty.closeWebApp("About");
            switty.closeWebApp("Transition");
            break;
    }
}