/**
 * JS Mobile Web Engine for mobile web applications
 * Author - Sergey Arkhipov
 */
var mwe = {
    
    timer: null,
    get: Array(),
    rotate : 0,
    
    init: 
        function() {
            //this.loader();
            this.get = this.queryString();
            this.includeCss("mwe/style.css");
        },
        
    start:
        function() {
                this.resize();
                $(document).resize(function(){this.resize();});
                $(window).resize(function(){this.resize();});
        },
    
    /*
     *
     * Server request
     */
    request:
        function(url) {
            this.includeScript(url);
        },
    /*
     *
     * Include
     */    
    includeCss:
        function(href) {
            var css = document.createElement("link");
            css.href = href;
            css.type = "text/css";
            css.rel = "stylesheet"
            document.getElementsByTagName("head")[0].appendChild(css);
        }, 
    includeScript:
        function(src, loadCallback) {
            script = document.createElement("script");
            script.src = src;
            script.type = "text/javascript";
            document.body.appendChild(script);
            if(loadCallback) script.onload = loadCallback;
        },        
    /*
     *
     * Drawing
     */
    loader: 
        function() {
            $("body").append("<div id=\"locker\"></div><div id=\"loader\"><div id=\"msg\" style=\"display: none;\"></div><div id=\"loading\"><img src=\"mwe/img/ajax-loader.png\" /></div></div>");
            this.rotateLoader();
            
        },
        
    rotateLoader: 
        function() {     
            $("#loader").bind("touchstart", function(){return false;}); 
            $("#locker").bind("touchstart", function(){return false;});
            setInterval(function() {$("#loading img").css({"-webkit-transform": "rotate("+mwe.rotate+"deg)"});mwe.rotate = mwe.rotate+15; }, 50);
        }, 
    
    resize:
        function() {            
            this.changeFontSize();
        },
        
    showLoad:
        function(timeout){
            $("#content").hide();
            $("#page").hide();
            if(timeout) app.timer = setTimeout(function() {app.showMsg("Ошибка подключения. Пожалуйста, обновите страницу.");}, 10000);
            $("#msg").hide();
            $("#loading").show();
            $("#loader").show();            
        },
        
    showMsg:
        function(text) {
            clearTimeout(app.timer);
            $("#loading").hide();
            $("#msg").show();
            $("#msg").html(text);
            $("#loader").show();
        },
        
    hideLoad:
        function() {
            clearTimeout(app.timer);
            $("#loader").hide();
            $("#content").show();
            $("#page").show();
        },   
        
    showLocker:
        function() {
            $("#locker").show();
        },
    hideLocker:
        function() {
            $("#locker").hide();
        },       
    
    toggleBlock:
        function(blockID, state, showBlockID) {
            if(state=="show") $("#"+blockID).show();
            else {
                $("#"+blockID).hide();
                if(showBlockID) $("#"+showBlockID).show();
            }
        },
    
    /*
     *
     * Touch hover
     */
    bindTouchState:
        function(selector, className) {
            
            className = className || "touchactive";
            var element = $(selector);

            if(typeof(document.ontouchstart)!="undefined") {
                element.bind("touchstart", function(){
                    element.addClass(className);
                });  
                element.bind("touchmove", function(){
                    element.removeClass(className);
                });
                element.bind("touchend", function(){
                    if(element.hasClass(className)) {
                        element.removeClass(className);
                    } 
                });
            }
        },
    unbindTouchState:
        function(selector) {
            var element = selector;
            if(typeof(document.ontouchend)!="undefined") {
                element.unbind("touchstart");
                element.unbind("touchmove");
                element.unbind("touchend");
            }
        },
            
    /*
     *
     * Get query params
     */ 
    
    queryString:
        function(string, defSep) {
            defSep = defSep || "?";
            string = string || window.location.href;
            sep = defSep;var tmp = new Array();var tmp_ = new Array();var param = new Array();var get = string;	
            if(get != "") {get = get.split(sep);if(get[1]) {tmp = get[1].split("&");for(var i=0; i < tmp.length; i++) {tmp_ = tmp[i].split("=");param[tmp_[0]] = tmp_[1];}}}   
            return param;
        },
        
    /*
     *
     * Storage methods
     */
    storage:
        function(key, value, remove) {
            if(typeof(localStorage) != "undefined" ) {
                if(!value) return localStorage.getItem(key);
                else {
                    if(!remove) localStorage.setItem(key, value); 
                    else localStorage.removeItem(key); 
                }    
            }
            return;
        },
            
    /*
     *
     * Font
     */
    
    changeFontSize:
        function() {
            var size = $("#content").width()/20;
            if(size>20) size = 20;
            $("body").css("font-size", size+"px");
        },
        
    /*
     * Common
     *
     */
    
    // Text
    strRepaet:
        function(input, multiplier) {
            return new Array(multiplier + 1).join(input);
        }, 
    genRandom:
        function(max) {
            return parseInt(Math.random()*max);
        },    
    
    // Social 
    share:
        function(social, title, url, img){
            if(social=="fb") url = "http://www.facebook.com/sharer.php?s=100&p[title]="+encodeURIComponent(title)+"&p[url]="+encodeURIComponent(url)+"&p[images][0]="+encodeURIComponent(img);
            if(social=="vk") url = "http://vkontakte.ru/share.php?title="+encodeURIComponent(title)+"&url="+encodeURIComponent(url)+"&image="+encodeURIComponent(img);
            window.open(url,'','toolbar=0,status=0,width=626,height=436');
        }
        
    /*
     * 
     * include core
     */ 
    
    /*include:
        function(appVar) {
            if(!this.coreInclude) {
                for(key in this) {
                    if(!appVar[key]) appVar[key] = this[key]; 
                }
                this.coreInclude = true;
                this.start();
            }
        }  */  
}        

/*
 * init 
 */
$(window).load(function(){
    mwe.init();
})
